-- Uniconnector.ms
-- 3.53
-- By Nikolay Litvinov (gniklit@gmail.com)
-- Created On:	2014-05-10
-- Modified:	2016-01-27
-- tested using Max 2012
messageBox "Category: \"Niklit Scripts\""
macroScript UniConnector Category:"Niklit Scripts" Tooltip:"UniConnector"
(
------------------------- Functions -------------------------
gco = modPanel.getCurrentObject()
global NewSpline, KnotPos_ar, selection_i, Es_


universal=null
struct polyFns
	(
		fn GetSelectionEdge fco node_i=fco.getselection #edge,
		fn SetSelectionEdge fco edges_bitA node_i=fco.SetSelection #Edge edges_bitA,
		fn getNumFaces_fn fco node_i=fco.getNumFaces()
	)
struct polyMODFns
	(
		fn GetSelectionEdge fco node_i=fco.getselection #edge node:selection[node_i],
		fn SetSelectionEdge fco edges_bitA node_i=(fco.SetSelection #Edge #{}; setEdgeSelection node_i fco edges_bitA keep:on),
		fn getNumFaces_fn fco node_i=fco.GetNumFaces node:selection[node_i]
	)

	fn tryInit fco =
		case classOf fco of
		(
			Editable_Poly: (universal = polyFns(); "Editable_Poly")
			Edit_Poly: (universal = polyMODFns(); "Edit_Poly")
		)

fn GabaritAssigner_fn=
(
try
(
myStart = pickobject()
myEnd = pickobject()
myStartVector=myStart.max-myStart.min
myEndVector=myEnd.max-myEnd.min
Nx=myEndVector.x/myStartVector.x
Ny=myEndVector.y/myStartVector.y
Nz=myEndVector.z/myStartVector.z
scale myStart [Nx,Ny,Nz]
max Select
)Catch()
)

fn AddModiferSuit_fn=(
if getCommandPanelTaskMode() != #modify then max modify mode
Try(Case superclassof selection[1] of
	 (	GeometryClass: modPanel.addModToSelection (Edit_Poly ()) ui:on
				Shape: modPanel.addModToSelection (Edit_Spline ()) ui:on
	 )
 	max select
	)Catch()
)

fn DrawLineBetweenTwoPoints_fn pointA pointB =
(
	ss = SplineShape pos:pointA
	addNewSpline ss
	addKnot ss 1 #corner #line PointA
	addKnot ss 1 #corner #line PointB
	updateShape ss
	ss
)

fn GetKnot_Pos_fn=(
SplCount = numSplines $
for spl=1 to SplCount do
for k=1 to (getKnotSelection $ spl).count 
do append KnotPos_ar (getKnotPoint $ spl ((getKnotSelection $ spl)[k]))
)

fn BridgeKnots_fn fco =(
	if classof fco == Edit_Spline
	then messageBox "Tool works except Edit Spline modifier" else
	(fco=$
	KnotPos_ar=#()
	GetKnot_Pos_fn()
	NewSpline=DrawLineBetweenTwoPoints_fn KnotPos_ar[1] KnotPos_ar[2]
	addAndWeld $ NewSpline 1
	)
)

fn ShapeConn_fn fco=(
case subobjectlevel of (
	1: BridgeKnots_fn fco
	2:(if classof fco != Edit_Spline then fco = $
		splineOps.divide fco)
	3:(if classof fco != Edit_Spline then fco = $

		spl_index_int=(getSplineSelection fco)[1]
		splCount=numSegments fco spl_index_int
		arSpl=for i=1 to splCount collect i
		for i=1 to numSplines fco do
		setSegSelection fco i #()
		setSegSelection fco spl_index_int arSpl keep: on
		subObjectLevel=2
		splineOps.divide fco
		subObjectLevel=3)
	)
)

fn TriFace_fn fco=(
NumF1=fco.getNumFaces()
if (isKindOf fco Edit_Poly or iskindof fco Editable_Poly)
do fco.CreateFace (fco.getSelection #Vertex as array)
try(fco.Commit())Catch()
NumF2=fco.getNumFaces()
NumF1 != NumF2
)

fn EdgeConnect_fn fco =(
NumF1=universal.getNumFaces_fn fco selection_i
fco.connectEdgeSegments=1
fco.ButtonOp #ConnectEdges
NumF2=universal.getNumFaces_fn fco selection_i
NumF1 != NumF2
)

fn BridgeBorder_fn fco =(
NumF1=fco.getNumFaces()
fco.ButtonOp #BridgeBorder
NumF2=fco.getNumFaces()
NumF1 != NumF2
)

fn BridgePolygon_fn fco =(
NumF1=fco.getNumFaces()
fco.ButtonOp #BridgePolygon
NumF2=fco.getNumFaces()
NumF1 != NumF2
)

fn BridgeEdge_fn fco =(
NumF1=universal.getNumFaces_fn fco selection_i
fco.ButtonOp #BridgeEdge
NumF2=universal.getNumFaces_fn fco selection_i
NumF1 != NumF2
)
fn DistanceConnect_fn=
try(
NumF1=$.numverts
macros.run "PolyTools" "DistanceConnect"
NumF2=$.numverts
NumF1 != NumF2
)catch()

fn GetViewDir_fn =(inverse(getViewTM())).row3

fn VertConnect_ThroughE_fn fco =(
arVs=for i=1 to selection.count collect (getVertSelection selection[i].mesh) as Array
startVertex_id=arVs[selection_i][1]
endPosition_p3=fco.GetVertex arVs[selection_i][2]
viewDirection_p3=GetViewDir_fn()

if iskindof fco Editable_poly do
fco.cutVertices startVertex_id endPosition_p3 viewDirection_p3
if iskindof fco Edit_poly do ( fco.StartCut #Vertex startVertex_id endPosition_p3 viewDirection_p3 node:selection[selection_i]; fco.Commit() )
)

fn EdgeConnect_ThroughE_fn fco =(
tryInit fco
arEs=for i=1 to selection.count collect (universal.GetSelectionEdge fco i) as Array
if arEs[selection_i].count==2 do
(
startEdge_id=arEs[selection_i][1]
EndEdge_id=arEs[selection_i][2]
viewDirection_p3=GetViewDir_fn()

if iskindof fco Editable_poly do
(fco.cutEdges startEdge_id .5 EndEdge_id .5 viewDirection_p3
arEs=fco.getSelection #Edge
fco.setSelection #Edge arEs)
if iskindof fco Edit_poly do
		(
		setVertSelection selection[selection_i] fco #{} keep:off
		for e in arEs[selection_i] do fco.DivideEdge e .5 node:selection[selection_i]; fco.Commit()
		arVs=for i=1 to selection.count collect (getVertSelection selection[selection_i].mesh) as Array
		startVertex_id=arVs[selection_i][1]
		endPosition_p3=fco.GetVertex arVs[selection_i][2] node:selection[selection_i]
		fco.setSelection #Edge #{} node:selection[selection_i]
		fco.StartCut #Vertex startVertex_id endPosition_p3 viewDirection_p3 node:selection[selection_i]; fco.Commit()
		)
	)
)

fn FilterOpenVert_fn fco =(
usOpenVert=(fco.getSelection #Vertex) as Array
OpenE=#()
resultType = openEdges.Check currentTime selection[1] &OpenE
allOpnVert=for e in OpenE collect fco.GetEdgeVertex e 1
FilterOpenVert = #()
	for i=1 to usOpenVert.count  do
	for j=1 to allOpnVert.count do
	if	 findItem allOpnVert usOpenVert[i]!=0 do appendIfUnique FilterOpenVert usOpenVert[i]
FilterOpenVert.count>2
)

fn PostWeld_fn fco = try (fco.weldThreshold=0.001; fco.buttonOp #WeldSelected)
catch (fco.weldVertexThreshold=0.001; fco.buttonOp #WeldVertex)

fn VertConn_fn fco =(
NumF1=fco.getNumFaces()
fco.ButtonOp #ConnectVertices
NumF2=fco.getNumFaces()
NumF1 != NumF2
)

fn so1_operation_fn fco =(
		if VertConn_fn fco==off do-- Connect Vertex
			if(
			cSys=getRefCoordSys()
			toolMode.coordsys #local
			NumF1=fco.getNumFaces()
			VertConnect_ThroughE_fn fco
			setRefCoordSys cSys
			PostWeld_fn fco
			NumF2=fco.getNumFaces()
			NumF1 != NumF2
			)==off do
	if FilterOpenVert_fn fco then TriFace_fn fco -- TriFace
	max select
	)

fn Divide_fn fco =(if classof fco==Editable_Poly do ($.selectedVerts=#{(fco.DivideEdge ((polyop.getEdgeSelection $)as array)[1] .5)})
		if classof fco==Edit_Poly do (fco.DivideEdge (Es_ as array)[1] .5 node:selection[selection_i]; fco.Commit()))

fn isEdgeStream_fn fco=
(
E_cur0=Es_ as array
universal.SetSelectionEdge fco #{E_cur0[1]} selection[selection_i]
UIAccessor.PressButton (for i in windows.getChildrenHWND #max where i[5]=="Ring"	do exit with i[1])
E_cur1=universal.GetSelectionEdge fco selection_i
universal.SetSelectionEdge fco (E_cur0 as BitArray) selection[selection_i]
isEdgeStream=not (#{E_cur0[2]}*E_cur1).isEmpty
)

fn so2_operation_fn fco =(
		if Es_.numberset==1 then Divide_fn fco else -- divide
		if (if Es_.numberset==2 do if isEdgeStream_fn fco do DistanceConnect_fn())==undefined then
		if EdgeConnect_fn fco == off then -- Edge Connect
		if (
			fco.SetSelection #Edge Es_ -- TriFace
			fco.ConvertSelection #Edge #Vertex
			Vs=fco.GetSelection #Vertex as array
			if Vs.count==3 then
				(subobjectlevel = 2
				TriFace_fn fco
				)
				else false
		)==off do if BridgeEdge_fn fco==off do (
		cSys=getRefCoordSys()
		toolMode.coordsys #local
		EdgeConnect_ThroughE_fn fco
		setRefCoordSys cSys
		)
)

fn so4_operation_fn fco =(
if (fco.getSelection #Face).numberset > 1 
then if BridgePolygon_fn fco==off do (fco.ToggleCommandMode #QuickSlice)
else (try fco.tesselateBy = 1 catch fco.tessellateByFace = 1; fco.buttonop #Tessellate; max select)
)

fn vSETi_sel_fn fco=(i_sel=1; Vet_ar=#()
				Vet_ar=for i=1 to selection.count collect (getVertSelection selection[i].mesh)
				while Vet_ar[i_sel].numberset==0 do i_sel+=1
				i_sel)
fn eSETi_sel_fn fco=(i_sel=1
				Edge_ar=for i=1 to selection.count collect (universal.GetSelectionEdge fco i)
				while Edge_ar[i_sel].numberset==0 do i_sel+=1
				i_sel)

------------------------- Script -------------------------
if selection.count==0 then GabaritAssigner_fn() else
if (subObjectLevel==0 or getCommandPanelTaskMode()!=#modify) do AddModiferSuit_fn()

if iskindof gco Editable_poly or iskindof gco Edit_poly do
Case subobjectlevel of
					(
					 1: (
							selected_arr=for i=1 to selection.count where not (getVertSelection selection[i].mesh).isEmpty collect ((getVertSelection selection[i].mesh)as array)
							if selected_arr.count>0 and selected_arr[1].count>1 then (selection_i=vSETi_sel_fn gco; so1_operation_fn gco) else
							case selected_arr.count of
							(
							0:(Btn_hwnd=for i in windows.getChildrenHWND #max where i[5]=="Cut"			do exit with i[1]; UIAccessor.PressButton Btn_hwnd)
							1:(Btn_hwnd=for i in windows.getChildrenHWND #max where i[5]=="Target Weld"	do exit with i[1]; UIAccessor.PressButton Btn_hwnd)
							--(Btn_hwnd=for i in windows.getChildrenHWND #max where i[5]=="Create Shape From Selection"	do exit with i[1]; UIAccessor.PressButton Btn_hwnd)
							)
						)
					 2: (
					 	tryInit gco
					 	selected_arr=for i=1 to selection.count where not (getEdgeSelection selection[i].mesh).isEmpty collect ((getEdgeSelection selection[i].mesh)as array)
						
					 	if selected_arr.count==0 do (Btn_hwnd=for i in windows.getChildrenHWND #max where i[5]=="Cut" do exit with i[1]; UIAccessor.PressButton Btn_hwnd)
						if selected_arr.count>0 do (selection_i=eSETi_sel_fn gco; Es_=universal.GetSelectionEdge gco selection_i; so2_operation_fn gco)
						)
					 3: (if BridgeBorder_fn gco == off do gco.ButtonOp #Cap; max select)
					 4: (if (gco.getSelection #Face).numberset == 0 then try gco.ToggleCommandMode #CutFace catch gco.ToggleCommandMode #Cut
							else so4_operation_fn gco)
					 5: gco.ToggleCommandMode #QuickSlice
					)
if superclassof gco == shape do try (ShapeConn_fn gco; max select) catch()
)